about summary refs log tree commit diff
diff options
context:
space:
mode:
-rw-r--r--tests/linux-sandbox.sh27
-rw-r--r--tests/local.mk3
2 files changed, 29 insertions, 1 deletions
diff --git a/tests/linux-sandbox.sh b/tests/linux-sandbox.sh
new file mode 100644
index 000000000000..740b2c357099
--- /dev/null
+++ b/tests/linux-sandbox.sh
@@ -0,0 +1,27 @@
+source common.sh
+
+clearStore
+
+if [[ $(uname) != Linux ]]; then exit; fi
+
+# Note: we need to bind-mount $SHELL into the chroot. Currently we
+# only support the case where $SHELL is in the Nix store, because
+# otherwise things get complicated (e.g. if it's in /bin, do we need
+# /lib as well?).
+if [[ ! $SHELL =~ /nix/store ]]; then exit; fi
+
+chmod -R u+w $TEST_ROOT/store0 || true
+rm -rf $TEST_ROOT/store0
+
+export NIX_STORE_DIR=/my/store
+export NIX_REMOTE="local?root=$TEST_ROOT/store0"
+
+outPath=$( nix-build dependencies.nix --no-out-link --option build-sandbox-paths /nix/store)
+
+[[ $outPath =~ /my/store/.*-dependencies ]]
+
+nix path-info -r $outPath | grep input-2
+
+nix ls-store -R -l $outPath | grep foobar
+
+nix cat-store $outPath/foobar | grep FOOBAR
diff --git a/tests/local.mk b/tests/local.mk
index b3ce39cda806..06532dc58d2b 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -11,7 +11,8 @@ nix_tests = \
   multiple-outputs.sh import-derivation.sh fetchurl.sh optimise-store.sh \
   binary-cache.sh nix-profile.sh repair.sh dump-db.sh case-hack.sh \
   check-reqs.sh pass-as-file.sh tarball.sh restricted.sh \
-  placeholders.sh nix-shell.sh
+  placeholders.sh nix-shell.sh \
+  linux-sandbox.sh
   # parallel.sh
 
 install-tests += $(foreach x, $(nix_tests), tests/$(x))